#include <sys/types.h>
#include <sys/time.h>
#include <fcntl.h>
#if defined(__linux__)
    #include "ttyent.h"
#else
    #include <ttyent.h>
#endif
#include <string.h>

#include <utmp.h>

#include "own_wtmp.h"
#include "libutil.h"

int init_utmp(reason)
char *reason;
{
  struct utmp u;
  int f = -1;
  struct ttyent *t;

  if(setttyent())
   {
    if((f = open(_PATH_UTMP, O_WRONLY|O_CREAT|O_TRUNC, 0664)) >= 0)
     {
      bzero(&u, sizeof(u));
      time(&u.ut_time);
   
      while (t = getttyent())
        write(f, &u, sizeof(u));
   
      close(f);
      logwtmp("~", reason, "");
     }
    endttyent();
   }

  return (f < 0);
}
